
Object subclass: #Student
  instanceVariableNames: 
    'name scores '
  classVariableNames: ''
  poolDictionaries: ''    !


!Student class methods ! !



!Student methods !
 
addScore: aNumber
    scores add: aNumber!
 
asString

    | str |
    str := '\>>> name: ', name, '\>>> tests: '.
    scores do: [ :scr | str := str, scr printString, ' '].
    str := str,
             '\>>> average: ', self average printString,
             '\>>> grade: ', self grade.
    ^str withCrs!

average
    | sum |
    scores size = 0 ifTrue: [^0].
    sum := scores inject: 0.0 into: [:runningSum :nextScore | runningSum + nextScore].
    ^sum / scores size!

grade
    | average |
    average := self average.
    average >= 90 ifTrue: [^'A'].
    average >= 80 ifTrue: [^'B'].
    average >= 70 ifTrue: [^'C'].
    average >= 60 ifTrue: [^'D'].
    ^'F'!
 
init
    name := ''.
    scores := OrderedCollection new!
 
name
    ^name!

name: aString
    name := aString! !
