
Object subclass: #GradingApp1
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !


!GradingApp1 class methods !
 
example
    self new open! !



!GradingApp1 methods !
 
open
        "Runs the grading program"
    | allStudents aStudent inName inScore sum classSize classAverage |

    allStudents := Dictionary new.

    "Enter student names and test scores. Store the students in the
    dictionary of allStudents."

    [inName := Prompter prompt: 'Name?' default: ''. inName = nil] whileFalse: [
        aStudent := Student new init.
        allStudents at: inName put: aStudent.
        aStudent name: inName.

    "Enter test scores for an individual student and store them in
    aStudent."

    [inScore := Prompter prompt: 'Score?' defaultExpression: ''.
        inScore = nil] whileFalse: [
        aStudent addScore: inScore]].

    "Compute and display the number of students and the class average."

    classSize := allStudents size.
    classSize = 0
        ifTrue: [^Menu message: 'There are no students in the class. The end.'].

    sum := 0.0.
    allStudents do: [:aStudent | sum := sum + aStudent average].
    classAverage := sum / classSize.
    Menu message: 'The average for ', classSize printString,
        ' students is ', classAverage printString.

    "Repeatedly prompt for a student's name and display
   the student's average and grade."

    [inName := Prompter prompt: 'Whose grades would you like?' default: ''.
        inName = nil] whileFalse: [
        (allStudents includesKey: inName)
            ifFalse: [Menu message: inName, ' not in class.']
            ifTrue: [
                aStudent := allStudents at: inName.
                Menu message: aStudent asString]].

    "Close the program"

    Menu message: 'Have a good day. The end.'! !
