
ViewManager subclass: #ListPaneDemo
  instanceVariableNames: 
    'listPane list selectedItem '
  classVariableNames: ''
  poolDictionaries: ''   !


!ListPaneDemo class methods ! !



!ListPaneDemo methods !
   
addAfter
    | item |
    selectedItem isNil ifTrue: [^Menu message: 'Select an item first'].
    item := Prompter prompt: 'New item' default: ''.
    item notNil
        ifTrue: [
            list add: item after: selectedItem.
            selectedItem := item.
            listPane
                contents: list;
                selection: selectedItem]!
 
addFirst
    | item |
    item := Prompter prompt: 'New item' default: ''.
    item notNil
        	ifTrue: [
            list addFirst: item.
            selectedItem := item.
            listPane
                contents: list;
                selection: selectedItem]!

getList: aListPane
    aListPane contents: list.
    aListPane selection: selectedItem!
   
itemSelected: aListPane
    selectedItem := aListPane selectedItem!

openOn: anOrderedCollection
    list := anOrderedCollection.
    selectedItem := nil.
    self label: 'List Pane Demo'.
    self addSubpane: (listPane := ListPane new
        owner: self;
        when: #getContents perform: #getList:;
        when: #select perform: #itemSelected:;
        framingRatio: (0.25 @ 0.25 extent: 0.5 @ 0.5)).
    self mainView menuWindow addMenu: (
        Menu new
            title: '~List';
            owner: self;
            appendItem: 'Add ~First' selector: #addFirst;
            appendItem: 'Add ~After' selector: #addAfter;
            appendItem: '~Remove' selector: #remove).
    self openWindow!
  
remove
    | item |
    selectedItem isNil ifTrue: [^Menu message: 'Select an item first'].
    list remove: selectedItem.
    selectedItem := nil.
    listPane
        contents: list;
        selection: selectedItem! !
