
Object subclass: #BankAccount
  instanceVariableNames: 
    'accountNumber balance customer '
  classVariableNames: ''
  poolDictionaries: '' !


!BankAccount class methods !
 
new
    ^super new init! !



!BankAccount methods !
   
accountNumber
    ^accountNumber!
  
accountNumber: aString
    accountNumber := aString!
   
asString
    ^(' ', (self class name), ' #', accountNumber, '\',
        '   balance: ', balance asDollarsAndCents, '\') withCrs!
 
customer
    ^customer!

customer: aString
    customer := aString!
 
deposit: aNumber
    balance := balance + aNumber!
 
init
    customer := 'Noneyet'.
    accountNumber := String new.
    balance := 0.00!

monthlyChargeOrInterest
    ^self implementedBySubclass!
   
withdraw: aNumber
    balance < aNumber ifTrue: [^'not accepted'].
    balance := balance - aNumber.
    ^'accepted'! !
